/*
    Aufgabe 4) Rekursion + Zweidimensionale Arrays - primitive Landschaftssimulation
*/

import codedraw.CodeDraw;

import java.awt.*;
import java.util.Random;

public class Aufgabe4 {

    private static final int canvasSize = 500;
    private static Random myRand = new Random(2021L);

    private static Color[][] genLandscape(int size) {
        // TODO: Implementieren Sie hier Ihre Lösung für die Angabe
        Color[][] landscape = new Color[size][size];
        for (int i = 0; i < size*size; i++) {
            landscape[i/size][i%size] = (myRand.nextDouble() < 0.2) ? Color.GRAY : Color.GREEN;
        }
        return landscape; //Zeile kann geändert oder entfernt werden.
    }

    private static void drawLandscape(CodeDraw myDrawObj, Color[][] landscape) {
        // TODO: Implementieren Sie hier Ihre Lösung für die Angabe

        for (int i = 0; i < landscape.length*landscape[0].length; i++) {
            myDrawObj.setColor(landscape[i/landscape.length][i% landscape[0].length]);
            myDrawObj.fillSquare((i%landscape.length)*5, (i/landscape[0].length)*5,5);
        }

        myDrawObj.show();
    }

    private static void simWaterFlow(Color[][] landscape, int row, int col) {
        // TODO: Implementieren Sie hier Ihre Lösung für die Angabe
        if (row < landscape.length && col < landscape[0].length && row >= 0 && col >= 0) {
            if (landscape[row][col] == Color.GREEN || landscape[row][col] == Color.BLUE){
                //Laut aufgabenstellung soll weiter fließen auch wenn 2 Flüsse aufeinandertreffen
                landscape[row][col] = Color.BLUE;
                boolean b = myRand.nextDouble() < 0.5;
                simWaterFlow(landscape, row + 1, (b) ? col + 1 : col - 1);
            } else if (landscape[row][col] == Color.GRAY) {
                landscape[row][col] = Color.DARK_GRAY;
                simWaterFlow(landscape, row, col - 1);
                simWaterFlow(landscape, row, col + 1);
            }

            //Wenn Dark Gray nicht weiter fließen

            //if (row <= landscape.length) drawLandscape(myDrawObject, landscape);
        }
    }

    private static void simSpreadingFire(Color[][] landscape, int row, int col) {
        // TODO: Implementieren Sie hier Ihre Lösung für die Angabe
        if (row < landscape.length && col < landscape[0].length && row >= 0 && col >= 0) {
            if (landscape[row][col] == Color.GREEN) {
                landscape[row][col] = Color.RED;
                //Norden
                if (myRand.nextDouble() >= 0.3) simSpreadingFire(landscape, row - 1, col);
                //Osten
                if (myRand.nextDouble() >= 0.3) simSpreadingFire(landscape, row, col + 1);
                //Süden
                if (myRand.nextDouble() >= 0.3) simSpreadingFire(landscape, row + 1, col);
                //Westen
                if (myRand.nextDouble() >= 0.3) simSpreadingFire(landscape, row, col - 1);
            }
        }
    }

    public static void main(String[] args) {
    	CodeDraw myDrawObj = new CodeDraw(canvasSize, canvasSize);

        int size = 100;
        Color[][] landscape = genLandscape(size);

        drawLandscape(myDrawObj, landscape);

        simWaterFlow(landscape, 0, size / 2);
        drawLandscape(myDrawObj, landscape);

        landscape[20][20] = Color.GREEN;
        simSpreadingFire(landscape, 20, 20);
        drawLandscape(myDrawObj, landscape);
    }
}
